-- /dev/null device by Jeff Fielding
integer k_null_fd, k_null_handler
k_null_fd = -1
function k_null_open(sequence s, sequence mode)
    if k_null_fd = -1 then
	k_null_fd = k_allocfd(k_null_handler)
    end if
    return k_null_fd
end function
function k_null_close(integer fd)
    return 0
end function
function k_null_read(integer fd, integer n)
    return -1
end function
function k_null_write(integer fd, object data)
    return 0
end function
function k_null_seek(integer fd, atom where)
    return -1
end function
function k_null_tell(integer fd)
    return -1
end function
function k_null_ioctl(integer fd, integer op, object x)
    return -1
end function
k_null_handler = k_new_fd_handler({routine_id("k_null_close"),
				   routine_id("k_null_read"),
				   routine_id("k_null_write"),
				   routine_id("k_null_seek"),
				   routine_id("k_null_tell"),
				   routine_id("k_null_ioctl")})
k_registerDevice("null",routine_id("k_null_open"))
